This patch is generated from the bugless-2_2 branch of s2_2 in squid
Fri Jan 30 10:15:11 2004 GMT
See http://devel.squid-cache.org/

Index: squid/include/hash.h
diff -u squid/include/hash.h:1.1.1.1 squid/include/hash.h:1.1.1.1.38.1
--- squid/include/hash.h:1.1.1.1	Tue Jan 25 19:21:47 2000
+++ squid/include/hash.h	Fri Nov 10 10:44:51 2000
@@ -24,8 +24,8 @@
 };
 
 extern hash_table *hash_create(HASHCMP *, int, HASHHASH *);
-extern void hash_join(hash_table *, hash_link *);
-extern void hash_remove_link(hash_table *, hash_link *);
+extern unsigned hash_join(hash_table *, hash_link *);
+extern unsigned hash_remove_link(hash_table *, hash_link *);
 extern int hashPrime(int n);
 extern void *hash_lookup(hash_table *, const void *);
 extern void hash_first(hash_table *);
Index: squid/lib/hash.c
diff -u squid/lib/hash.c:1.1.1.2 squid/lib/hash.c:1.1.1.2.12.1
--- squid/lib/hash.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/lib/hash.c	Fri Nov 10 10:44:51 2000
@@ -163,14 +163,23 @@
  *
  *  It does not copy any data into the hash table, only links pointers.
  */
-void
+unsigned
 hash_join(hash_table * hid, hash_link * lnk)
 {
     int i;
     i = hid->hash(lnk->key, hid->size);
+#if 1
+    { /* srb */
+	hash_link * ol;
+	for (ol = hid->buckets[i]; ol; ol = ol->next)
+	    if (ol == lnk)
+		return 1;
+    }
+#endif
     lnk->next = hid->buckets[i];
     hid->buckets[i] = lnk;
     hid->count++;
+    return 0;
 }
 
 /*
@@ -252,7 +261,7 @@
  *  On success, it returns 0 and deletes the link; otherwise, 
  *  returns non-zero on error.
  */
-void
+unsigned
 hash_remove_link(hash_table * hid, hash_link * hl)
 {
     hash_link **P;
@@ -269,9 +278,12 @@
 		hash_next_bucket(hid);
 	}
 	hid->count--;
-	return;
+	return 0;
     }
+#if 0 /* srb */
     assert(0);
+#endif
+    return 1;
 }
 
 /*
Index: squid/lib/heap.c
diff -u /dev/null squid/lib/heap.c:1.3.6.1
--- /dev/null	Fri Jan 30 02:14:14 2004
+++ squid/lib/heap.c	Fri Nov 10 10:44:51 2000
@@ -0,0 +1,575 @@
+#define HPL_REPL	1
+/****************************************************************************
+ * Heap implementation
+ ****************************************************************************/
+
+#include <stdlib.h>
+#include "malloc.h"
+#include <assert.h>
+#include <string.h>
+#include <stdio.h>
+
+#include "heap.h"
+
+/* 
+ * Private function prototypes.
+ */
+static void _heap_ify_up(heap_p hp, heap_node_p elm);
+static void _heap_ify_down(heap_p hp, heap_node_p elm);
+static int _heap_should_grow(heap_p hp);
+static void _heap_grow(heap_p hp);
+static void _heap_swap_element(heap_p hp, heap_node_p elm1, heap_node_p elm2);
+static unsigned _heap_node_exist(heap_p hp, int id);
+
+#ifdef	HEAP_DEBUG
+void _heap_print_tree(heap_p hp, heap_node_p node);
+#endif	/* HEAP_DEBUG */
+
+#define Left(x) (2 * (size_t)(x) + 1)
+#define Right(x) (2 * (size_t)(x) + 2)
+#define Parent(x) (((size_t)(x)-1)/2)
+
+#define Threshold 10000
+#define NormalRate 2
+#define SlowRate 1.5
+#define MinSize 32
+
+/****************************************************************************
+ * Public functions
+ ****************************************************************************/
+
+/*
+ * Return a newly created heap. INITSIZE is the initial size of the heap.
+ */
+heap_p
+new_heap(int initSize, key_func gen_key, size_t nodeoffset)
+{
+  heap_p hp = (heap_p) malloc(sizeof(heap));
+  assert(hp != NULL);
+
+  if (initSize <= 0)
+    initSize = MinSize;
+
+  hp->nodes = (heap_node_p *)calloc(initSize, sizeof(heap_node_p));
+  assert(hp->nodes != NULL);
+
+  hp->size = initSize;
+  hp->last = 0;
+  hp->gen_key = gen_key;
+  hp->nodeoffset = nodeoffset;
+  hp->age = 0;
+
+  return hp;
+}
+
+
+/*
+ * Free memory used by a heap.  Does not free the metadata pointed to by the
+ * heap nodes, only the heap's internal memory.
+ */
+void
+delete_heap(heap_p hp)
+{
+  int i;
+  assert(hp);
+  free(hp->nodes);
+  free(hp);
+}
+
+/* 
+ * True if a node with ID exists in HP.
+ */
+static unsigned
+_heap_node_exist(heap_p hp, int id)
+{
+  if ((id >= hp->last) || (id < 0) || (hp->nodes[(size_t)id] == NULL) ||
+	hp->nodes[(size_t)id]->id != id)
+    return 0;
+  return 1;
+}
+
+/*
+ * Insert DAT based on KY into HP maintaining the heap property.  Return the
+ * newly inserted heap node. The fields of ELM other than ID are never
+ * changed until ELM is deleted from HP, i.e. caller can assume that the
+ * heap node always exist at the same place in memory unless heap_delete or
+ * heap_extractmin is called on that node.  This function exposes the heap's
+ * internal data structure to the caller.  This is required in order to do
+ * O(lgN) deletion.
+ */
+heap_node_p 
+heap_insert(heap_p hp, void * dat)
+{
+  heap_node* elm = heap_ELM(hp, dat);
+
+  elm->key = heap_gen_key(hp, dat);
+
+  if (_heap_should_grow(hp))
+    _heap_grow(hp);
+
+  hp->nodes[(size_t)hp->last] = elm;
+  elm->id = hp->last++;
+
+  _heap_ify_up(hp, elm);
+
+  /* 
+   * Set the pointer in the metadata to point to this heap node.
+   */
+  #ifdef	HPL_REPL
+  /* The following must be done immediately upon return! */
+  #else	/* HPL_REPL */
+  md_set_node(dat, elm);
+  #endif	/* HPL_REPL */
+
+  return elm;
+}
+
+static
+void _heap_order(heap_p hp, heap_node_p elm)
+{
+  if (elm->id > 0 &&
+	elm->key < hp->nodes[Parent(elm->id)]->key)
+      _heap_ify_up(hp, elm);			/* COOL! */
+  _heap_ify_down(hp, elm);
+}
+
+/*
+ * Delete ELM while maintaining the heap property. ELM may be modified.
+ * Assumes that ELM is not NULL and frees it.  Returns the data pointed to
+ * in, which the caller must free if necessary.
+ */
+_HEAPTYPE
+heap_delete(heap_p hp, heap_node_p elm)
+{
+  heap_node_p lastNode;
+  _HEAPTYPE data = heap_DATA(hp, elm);
+
+  assert(_heap_node_exist(hp, hp->last-1));
+
+  if (elm->id != --hp->last) {
+    lastNode = hp->nodes[(size_t)hp->last];
+    hp->nodes[(size_t)elm->id] = lastNode;
+    lastNode->id = elm->id;
+
+    _heap_order(hp, lastNode);
+  }
+
+  /* 
+   * Remove the pointer back to the heap from the metadata.
+   * Then free the element that was just deleted.
+   */
+  #ifdef	HPL_REPL
+  /* The following must be done immediately upon return! */
+  #else	/* HPL_REPL */
+  md_set_node(data, NULL);
+  #endif	/* HPL_REPL */
+
+  return data;
+}
+
+/* 
+ * Delete the last element (leaf) out of the heap.  Does not require a
+ * heapify operation.
+ */
+
+#ifndef	heap_gen_key
+/*
+ * Function to generate keys.  See macro definition in heap.h.
+ */
+_HEAPKEY
+heap_gen_key(heap_p hp, _HEAPTYPE dat)
+{
+  return hp->gen_key(dat, hp->age);
+}
+#endif	/* heap_gen_key */
+
+
+/* 
+ * Returns the data of the node with the largest KEY value and removes that
+ * node from the heap.  Returns NULL if the heap was empty.
+ */
+_HEAPTYPE
+heap_extractmin(heap_p hp)
+{
+  if (hp->last <= 0)
+    return NULL;
+
+  return heap_delete(hp, hp->nodes[0]);		/* Delete the root */
+}
+
+
+/* 
+ * Remove the last node in HP.  Frees the heap internal structure and
+ * returns the data pointes to by the last node.
+ */
+_HEAPTYPE
+heap_extractlast(heap_p hp)
+{
+  _HEAPTYPE data;
+  assert (_heap_node_exist(hp, hp->last-1));
+  data = heap_DATA(hp, hp->nodes[(size_t)--hp->last]);
+  return data;
+}
+
+
+/* 
+ * The semantics of this routine is the same as the followings:
+ *        heap_delete(hp, elm);
+ *        heap_insert(hp, dat);
+ * Returns the old data object from elm (the one being replaced).  The
+ * caller must free this as necessary.
+ */
+void
+heap_update(heap_p hp, heap_node* elm)
+{
+  _HEAPTYPE dat = heap_DATA(hp, elm);
+  _HEAPKEY ky = heap_gen_key(hp, dat);
+  assert (_heap_node_exist(hp, elm->id));
+
+  elm->key = ky;
+
+  _heap_order(hp, elm);
+}
+
+
+/* 
+ * A pointer to the root node's DATA.
+ */
+void*
+heap_peepmin(heap_p hp)
+{
+  assert(_heap_node_exist(hp, 0));
+  return heap_DATA(hp, hp->nodes[0]);
+}
+
+
+/* 
+ * The KEY of the root node.
+ */
+_HEAPKEY
+heap_peepminkey(heap_p hp)
+{
+  assert(_heap_node_exist(hp, 0));
+  return hp->nodes[0]->key;
+}
+
+
+/* 
+ * Same as heap_peep except that this return the KEY of the node.
+ * Only meant for iteration.
+ */
+_HEAPKEY
+heap_peepkey(heap_p hp, int n)
+{
+  assert(_heap_node_exist(hp, n));
+  return hp->nodes[(size_t)n]->key;
+}
+
+
+/* 
+ * A pointer to Nth node's DATA. The caller can iterate through HP by
+ * calling this routine.  eg. Caller can execute the following code:
+ *   for(i = 0; i < heap_nodes(hp); i++)
+ *      data = heap_peep(hp, i);
+ */
+void*
+heap_peep(heap_p hp, int n)
+{
+  assert(_heap_node_exist(hp, n));
+  return heap_DATA(hp, hp->nodes[(size_t)n]);
+}
+
+
+#ifndef	heap_nodes
+/* 
+ * Current number of nodes in HP.
+ */
+int
+heap_nodes(heap_p hp)
+{
+  return hp->last;
+}
+#endif	/* heap_nodes */
+
+
+#ifndef	heap_empty
+/* 
+ * Determine if the heap is empty.  Returns 1 if HP has no elements and 0
+ * otherwise.
+ */
+int
+heap_empty(heap_p hp)
+{
+  return (hp->last <= 0) ? 1 : 0;
+}
+#endif	/* heap_empty */
+
+/****************** Private Functions *******************/
+
+/* 
+ * Maintain the heap order property (parent is smaller than children) which
+ * may only be violated at ELM downwards.  Assumes caller has locked the heap.
+ */
+static void
+_heap_ify_down(heap_p hp, heap_node_p elm)
+{
+  heap_node* kid;
+  int left, right;
+  for(;;) {
+    assert(_heap_node_exist(hp, elm->id));
+    left = Left(elm->id);
+    right = Right(elm->id);
+    if (hp->last <= left)               // At the bottom of the heap (no child).
+      break;
+    else if (hp->last <= right) {       // Only left child exists.
+      assert(_heap_node_exist(hp, left));
+      kid = hp->nodes[(size_t)left];
+    } else {
+      assert(_heap_node_exist(hp, left));
+      assert(_heap_node_exist(hp, right));
+      if (hp->nodes[(size_t)right]->key < hp->nodes[(size_t)left]->key)
+	kid = hp->nodes[(size_t)right];
+      else
+	kid = hp->nodes[(size_t)left];
+    }
+    if (elm->key <= kid->key)
+      break;
+    _heap_swap_element(hp, kid, elm);
+  }
+}
+
+
+/* 
+ * Maintain the heap property above ELM.  Caller has locked the heap.
+ */
+static void
+_heap_ify_up(heap_p hp, heap_node_p elm)
+{
+  heap_node_p parentNode;
+  assert(_heap_node_exist(hp, elm->id));
+  while (elm->id > 0) {
+    assert(_heap_node_exist(hp, elm->id));
+    parentNode = hp->nodes[Parent(elm->id)];
+    assert(_heap_node_exist(hp, parentNode->id));
+    if (parentNode->key <= elm->key)
+      break;
+    _heap_swap_element(hp, parentNode, elm);  /* Demote the parent. */
+  }
+}
+
+
+/* 
+ * Swap the position of ELM1 and ELM2 in heap structure. Their IDs are also
+ * swapped. 
+ */
+static void
+_heap_swap_element(heap_p hp, heap_node_p elm1, heap_node_p elm2)
+{
+  int elm1Id = elm1->id;
+  elm1->id = elm2->id;
+  elm2->id = elm1Id;
+  hp->nodes[(size_t)elm1->id] = elm1;
+  hp->nodes[(size_t)elm2->id] = elm2;
+}
+
+
+
+#ifdef	NOTDEF
+/* 
+ * Copy KEY and DATA fields of SRC to DEST. ID field is NOT copied.
+ */
+static void
+_heap_copy_element(heap_node_p src, heap_node_p dest)
+{
+  dest->key = src->key;
+}
+#endif	/* NOTDEF */
+
+
+/* 
+ * True if HP needs to be grown in size.
+ */
+static int
+_heap_should_grow(heap_p hp)
+{
+  if (hp->size <= hp->last)
+    return 1;
+  return 0;
+}
+
+
+/* 
+ * Grow HP.
+ */
+static void
+_heap_grow(heap_p hp)
+{
+  int newSize;
+  //heap_node_p * newNodes;
+
+  if (hp->size > Threshold)
+    newSize = hp->size * SlowRate;
+  else
+    newSize = hp->size * NormalRate;
+
+  hp->nodes = (heap_node_p *)realloc(hp->nodes, newSize * sizeof(heap_node_p));
+  //for(i = 0; i < hp->size; i++)
+    //newNodes[i] = hp->nodes[i];
+  //free(hp->nodes);
+  //hp->nodes = newNodes;
+  hp->size = newSize;
+}
+
+
+/****************************************************************************
+ * Printing and debug functions
+ ****************************************************************************/
+
+/* 
+ * Print the heap in element order, id..last. 
+ */
+void
+heap_print_inorder(heap_p hp, int id)
+{
+  while (id < hp->last) {
+    printf("%d <- %d -> %d\tKey = %.04f\n", Parent(id), id, Left(id), hp->nodes[id]->key);
+    id++;
+  }
+}
+
+/*
+ * Returns 1 if HP maintians the heap property and 0 otherwise.
+ */
+int
+verify_heap_property(heap_p hp)
+{
+  int i = 0;
+  int correct = 1;
+  for(i = 0; i < hp->last / 2; i++) {
+    correct = 1;
+    if (_heap_node_exist(hp, Left(i)))
+      if (hp->nodes[i]->key > hp->nodes[Left(i)]->key)
+	correct = 0;
+    if (_heap_node_exist(hp, Right(i)))
+      if (hp->nodes[i]->key > hp->nodes[Right(i)]->key)
+	correct = 0;
+    if (!correct) {
+      printf("verifyHeap: violated at %d", i);
+      heap_print_inorder(hp, 0);
+      break;
+    }
+  }
+  return correct;
+}
+
+#ifdef	MEASURE_HEAP_SKEW
+
+/****************************************************************************
+ * Heap skew computation
+ ****************************************************************************/
+
+int 
+compare_heap_keys(const void * a, const void * b)
+{
+  heap_node ** an = (heap_node**)a;
+  heap_node ** bn = (heap_node**)b;
+  float cmp = (*an)->key - (*bn)->key;
+  if (cmp < 0)
+    return -1;
+  else
+    return 1;
+}
+
+/*
+ * Compute the heap skew for HEAP, a measure of how out-of-order the
+ * elements in the heap are.  The skew of a heap node is the difference
+ * between its current position in the heap and where it would be if the
+ * heap were in sorted order.  To compute this we have to sort the heap.  At
+ * the end if the flag REPLACE is non-zero the heap will be returned in
+ * sorted order (with skew == 0).  Note: using REPLACE does not help the
+ * performance of the heap, so only do this if you really want to have a
+ * sorted heap.  It is faster not to replace.
+ */
+float
+calc_heap_skew(heap_p heap, int replace)
+{
+  heap_node ** nodes;
+  long id, diff, skew = 0;
+  #ifdef	HEAP_DEBUG_SKEW
+  long skewsq = 0;
+  #endif	/* HEAP_DEBUG_SKEW */
+  float norm = 0;
+  unsigned long max;
+
+  /* 
+   * Lock the heap to copy it.  If replacing it need to keep the heap locked
+   * until we are all done.
+   */
+  mutex_lock(hp->lock);
+
+  max = heap_nodes(heap);
+
+  /* 
+   * Copy the heap nodes to a new storage area for offline sorting.
+   */
+  nodes = (heap_node **)malloc(max * sizeof(heap_node *));
+  memcpy(nodes, heap->nodes, max * sizeof(heap_node *));
+
+  if (replace == 0) {
+    /* 
+     * Unlock the heap to allow updates from other threads before the sort.
+     * This allows other heap operations to proceed concurrently with the
+     * heap skew computation on the heap at the time of the call ...
+     */
+    mutex_unlock(hp->lock);
+  }
+
+  qsort(nodes, max, sizeof(heap_node *), compare_heap_keys);
+
+  for (id=0; id < max; id++) {
+    diff = id - nodes[id]->id;
+    skew += abs(diff);
+
+    #ifdef	HEAP_DEBUG_SKEW
+    skewsq += diff*diff;
+    #ifdef	HEAP_DEBUG_ALL
+    printf("%d\tKey = %f, diff = %d\n", id, nodes[id]->key, diff);
+    #endif	/* HEAP_DEBUG */
+    #endif	/* HEAP_DEBUG_SKEW */
+  }
+
+  if (replace != 0) {
+    /* 
+     * Replace the original heap with the newly sorted heap and let it
+     * continue.  Then compute the skew using the copy of the previous heap
+     * which we maintain as private data.
+     */
+    memcpy(heap->nodes, nodes, max * sizeof(heap_node *));
+
+    for (id = 0; id < max; id++) {
+      /* 
+       * Fix up all the ID values in the copied nodes.
+       */
+      heap->nodes[id]->id = id;
+    }
+
+    mutex_unlock(hp->lock);
+  }
+
+  /* 
+   * The skew value is normalized to a range of [0..1]; the distribution
+   * appears to be a skewed Gaussian distribution.  For random insertions
+   * into a heap the normalized skew will be slightly less than 0.5.  The
+   * maximum value of skew/N^2 (for any value of N) is about 0.39 and is
+   * fairly stable.
+   */
+  norm = skew*2.56/(max*max);
+
+  /* 
+   * Free the nodes array; note this is just an array of pointers, not data!
+   */
+  free(nodes);
+  return norm;
+}
+
+#endif	/* MEASURE_HEAP_SKEW */
Index: squid/src/HttpHdrRange.c
diff -u squid/src/HttpHdrRange.c:1.1.1.2 squid/src/HttpHdrRange.c:1.1.1.2.12.1
--- squid/src/HttpHdrRange.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/HttpHdrRange.c	Fri Nov 10 10:44:52 2000
@@ -462,7 +462,7 @@
     assert(http);
     stringAppend(&b, full_appname_string, strlen(full_appname_string));
     stringAppend(&b, ":", 1);
-    key = storeKeyText(http->entry->key);
+    key = storeKeyText(http->entry->Skey);
     stringAppend(&b, key, strlen(key));
     return b;
 }
Index: squid/src/MemPool.c
diff -u squid/src/MemPool.c:1.1.1.2 squid/src/MemPool.c:1.1.1.2.12.1
--- squid/src/MemPool.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/MemPool.c	Fri Nov 10 10:44:52 2000
@@ -204,7 +204,20 @@
     assert(label && obj_size);
     pool->label = label;
     pool->obj_size = obj_size;
-    stackInit(&pool->pstack);
+    pool->pstack = 0;
+    pool->ss = pool;
+#ifdef SSPOOLS
+    {
+	unsigned i;
+	for (i = 0; i < Pools.count; i++) {
+	    MemPool *np = Pools.items[i];
+	    if (np->obj_size == pool->obj_size && pool != np) {
+		pool->ss = np;
+		break;
+	    }
+	}
+    }
+#endif
     /* other members are set to 0 */
     stackPush(&Pools, pool);
     return pool;
@@ -218,56 +231,83 @@
 memPoolDestroy(MemPool * pool)
 {
     assert(pool);
-    stackClean(&pool->pstack);
     xfree(pool);
 }
 
 void *
 memPoolAlloc(MemPool * pool)
 {
+    void *obj;
     assert(pool);
     memMeterInc(pool->meter.inuse);
     gb_inc(&pool->meter.total, 1);
     gb_inc(&TheMeter.total, pool->obj_size);
     memMeterAdd(TheMeter.inuse, pool->obj_size);
     gb_inc(&mem_traffic_volume, pool->obj_size);
+#ifdef NEVERFREE
+    if (!(obj = pool->ss->pstack)) {
+	unsigned step = pool->meter.alloc.level/4+1;	/* 25% growth */
+	if (step*pool->obj_size>256*1024)
+	    step = 256*1024/pool->obj_size;   /* but at most 256KB at a time */
+	obj = xmalloc(step*pool->obj_size);
+	memMeterAdd(pool->meter.alloc, step);
+	memMeterAdd(TheMeter.alloc, step*pool->obj_size);
+	while(--step) {
+	    memPoolFree(pool, obj);
+	    obj=(char*)obj+pool->obj_size;
+            memMeterInc(pool->meter.inuse);
+            memMeterAdd(TheMeter.inuse, pool->obj_size);
+	}
+#else
     if (pool->pstack.count) {
-	assert(pool->meter.idle.level);
-	memMeterDec(pool->meter.idle);
+	assert(!pool->meter.idle.level);
+	return xcalloc(1, pool->obj_size);
+#endif
+    } else {
+	memMeterDec(pool->ss->meter.idle);
+        memMeterDec(pool->ss->meter.alloc);
+        memMeterInc(pool->meter.alloc);
 	memMeterDel(TheMeter.idle, pool->obj_size);
 	gb_inc(&pool->meter.saved, 1);
 	gb_inc(&TheMeter.saved, pool->obj_size);
-	return stackPop(&pool->pstack);
-    } else {
-	assert(!pool->meter.idle.level);
-	memMeterInc(pool->meter.alloc);
-	memMeterAdd(TheMeter.alloc, pool->obj_size);
-	return xcalloc(1, pool->obj_size);
+	pool->ss->pstack = *(void**)obj;
     }
+    memset(obj, 0, pool->obj_size);
+    return obj;
 }
 
 void
 memPoolFree(MemPool * pool, void *obj)
 {
     assert(pool && obj);
+    assert(pool->obj_size >= sizeof pool->pstack);
     memMeterDec(pool->meter.inuse);
+    memMeterDec(pool->meter.alloc);
+    memMeterInc(pool->ss->meter.alloc);
     memMeterDel(TheMeter.inuse, pool->obj_size);
+#ifdef NEVERFREE
+    if (1) {
+#else
     if (TheMeter.idle.level + pool->obj_size <= mem_idle_limit) {
-	memMeterInc(pool->meter.idle);
+#endif
+	memMeterInc(pool->ss->meter.idle);
 	memMeterAdd(TheMeter.idle, pool->obj_size);
-	memset(obj, 0, pool->obj_size);
-	stackPush(&pool->pstack, obj);
+	*(void**)obj = pool->ss->pstack;
+	pool->ss->pstack = obj;
     } else {
 	memMeterDec(pool->meter.alloc);
 	memMeterDel(TheMeter.alloc, pool->obj_size);
 	xfree(obj);
     }
+#if 0	/* bogus assertion? srb */
     assert(pool->meter.idle.level <= pool->meter.alloc.level);
+#endif
 }
 
 static void
 memPoolShrink(MemPool * pool, size_t new_limit)
 {
+#ifndef NEVERFREE
     assert(pool);
     assert(new_limit >= 0);
     while (pool->meter.idle.level > new_limit && pool->pstack.count > 0) {
@@ -278,13 +318,15 @@
 	xfree(stackPop(&pool->pstack));
     }
     assert(pool->meter.idle.level <= new_limit);	/* paranoid */
+#endif
 }
 
 int
 memPoolWasUsed(const MemPool * pool)
 {
     assert(pool);
-    return pool->meter.alloc.hwater_level > 0;
+    return pool->meter.inuse.hwater_level > 0 ||
+	pool->meter.idle.hwater_level > 0;
 }
 
 int
@@ -358,8 +400,7 @@
 	    idle_count += pool->meter.idle.level;
 	}
 	overhd_size += sizeof(MemPool) + sizeof(MemPool *) +
-	    strlen(pool->label) + 1 +
-	    pool->pstack.capacity * sizeof(void *);
+	    strlen(pool->label) + 1;
     }
     overhd_size += sizeof(Pools) + Pools.capacity * sizeof(MemPool *);
     /* totals */
Index: squid/src/aiops.c
diff -u squid/src/aiops.c:1.1.1.2 squid/src/aiops.c:1.1.1.2.10.1
--- squid/src/aiops.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/aiops.c	Fri Nov 10 10:44:52 2000
@@ -385,9 +385,14 @@
 	high_start = 0;
     }
     if (request_queue_len > RIDICULOUS_LENGTH) {
+	static unsigned warned;
+	if (!warned)
 	debug(43, 0) ("aio_queue_request: Async request queue growing uncontrollably!\n");
+	warned=1;
+#if 0
 	debug(43, 0) ("aio_queue_request: Possible infinite loop somewhere in squid. Restarting...\n");
 	abort();
+#endif
     }
 }				/* aio_queue_request */
 
@@ -577,7 +582,9 @@
 aio_do_read(aio_request_t * requestp)
 {
     lseek(requestp->fd, requestp->offset, requestp->whence);
-    requestp->ret = read(requestp->fd, requestp->tmpbufp, requestp->buflen);
+    while((requestp->ret =
+	read(requestp->fd, requestp->tmpbufp, requestp->buflen)) < 0 &&
+	errno == EAGAIN);
     requestp->err = errno;
 }
 
@@ -615,7 +622,9 @@
 static void
 aio_do_write(aio_request_t * requestp)
 {
-    requestp->ret = write(requestp->fd, requestp->tmpbufp, requestp->buflen);
+    while((requestp->ret =
+	write(requestp->fd, requestp->tmpbufp, requestp->buflen)) < 0 &&
+	errno == EAGAIN);
     requestp->err = errno;
 }
 
@@ -644,7 +653,10 @@
 static void
 aio_do_close(aio_request_t * requestp)
 {
-    requestp->ret = close(requestp->fd);
+    if((requestp->ret = close(requestp->fd))<0) {
+	debug(43, 0) ("aio_do_close: FD %d, errno %d\n", requestp->fd, errno);
+	close(requestp->fd);
+    }
     requestp->err = errno;
 }
 
Index: squid/src/asn.c
diff -u squid/src/asn.c:1.1.1.2 squid/src/asn.c:1.1.1.2.10.1
--- squid/src/asn.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/asn.c	Fri Nov 10 10:44:52 2000
@@ -221,7 +221,7 @@
     char *s;
     char *t;
     debug(53, 3) ("asHandleReply: Called with size=%d\n", size);
-    if (EBIT_TEST(e->flags, ENTRY_ABORTED)) {
+    if (EBIT_TEST(e->Sflag, ENTRY_ABORTED)) {
 	memFree(buf, MEM_4K_BUF);
 	asStateFree(asState);
 	return;
Index: squid/src/async_io.c
diff -u squid/src/async_io.c:1.1.1.2 squid/src/async_io.c:1.1.1.2.10.1
--- squid/src/async_io.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/async_io.c	Fri Nov 10 10:44:52 2000
@@ -132,7 +132,8 @@
     ctrlp->done_handler_data = NULL;
     ctrlp->operation = _AIO_CLOSE;
     if (aio_close(fd, &(ctrlp->result)) < 0) {
-	close(fd);		/* Can't create thread - do a normal close */
+	if(close(fd))		/* Can't create thread - do a normal close */
+	    debug(0,0) ("aioClose: FD %d, errno %d\n", fd, errno), close(fd);
 	memPoolFree(aio_ctrl_pool, ctrlp);
 	fd_was_closed(fd);
 	return;
Index: squid/src/cache_cf.c
diff -u squid/src/cache_cf.c:1.1.1.2 squid/src/cache_cf.c:1.1.1.2.10.1
--- squid/src/cache_cf.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/cache_cf.c	Fri Nov 10 10:44:52 2000
@@ -222,7 +222,7 @@
     /* calculate Config.Swap.maxSize */
     storeDirConfigure();
     if (Config.Swap.maxSize < (Config.memMaxSize >> 10))
-	fatal("cache_swap is lower than cache_mem");
+	debug(3, 0) ("configDoConfigure: cache_swap is lower than cache_mem");
     if (Config.Announce.period > 0) {
 	Config.onoff.announce = 1;
     } else if (Config.Announce.period < 1) {
@@ -303,10 +303,14 @@
 	debug(3, 0) ("WARNING: resetting 'maximum_single_addr_tries to 1\n");
 	Config.retry.maxtries = 1;
     }
+    #ifdef	HPL_REPL
+    /* The non-LRU policies do not use referenceAge */
+    #else	/* HPL_REPL */
     if (Config.referenceAge < 300) {
 	debug(3, 0) ("WARNING: resetting 'reference_age' to 1 week\n");
 	Config.referenceAge = 86400 * 7;
     }
+    #endif	/* HPL_REPL */
     requirePathnameExists("MIME Config Table", Config.mimeTablePathname);
     requirePathnameExists("cache_dns_program", Config.Program.dnsserver);
     requirePathnameExists("unlinkd_program", Config.Program.unlinkd);
@@ -837,6 +841,9 @@
     tmp->l2 = l2;
     tmp->flags.read_only = read_only;
     tmp->swaplog_fd = -1;
+#ifdef MMAPSTORE
+    tmp->mi = 0;
+#endif
     swap->n_configured++;
 }
 
@@ -856,6 +863,7 @@
 	}
 	xfree(s->path);
 	filemapFreeMemory(s->map);
+	delete_heap(s->heap);
     }
     safe_free(swap->swapDirs);
     swap->swapDirs = NULL;
Index: squid/src/cache_manager.c
diff -u squid/src/cache_manager.c:1.1.1.2 squid/src/cache_manager.c:1.1.1.2.28.1
--- squid/src/cache_manager.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/cache_manager.c	Fri Nov 10 10:44:52 2000
@@ -201,12 +201,12 @@
 	err = errorCon(ERR_INVALID_URL, HTTP_NOT_FOUND);
 	err->url = xstrdup(storeUrl(entry));
 	errorAppendEntry(entry, err);
-	entry->expires = squid_curtime;
+	entry->Sexpires = squid_curtime;
 	return;
     }
     mgr->entry = entry;
     storeLockObject(entry);
-    entry->expires = squid_curtime;
+    entry->Sexpires = squid_curtime;
     debug(16, 5) ("CACHEMGR: %s requesting '%s'\n",
 	fd_table[fd].ipaddr, mgr->action);
     /* get additional info from request headers */
@@ -238,7 +238,7 @@
 	httpReplyAbsorb(entry->mem_obj->reply, rep);
 	/* store the reply */
 	httpReplySwapOut(entry->mem_obj->reply, entry);
-	entry->expires = squid_curtime;
+	entry->Sexpires = squid_curtime;
 	storeComplete(entry);
 	cachemgrStateFree(mgr);
 	return;
Index: squid/src/cachemgr.c
diff -u squid/src/cachemgr.c:1.1.1.2 squid/src/cachemgr.c:1.1.1.2.12.1
--- squid/src/cachemgr.c:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/cachemgr.c	Fri Nov 10 10:44:52 2000
@@ -344,7 +344,7 @@
 {
     static const char *ttags[] =
     {"td", "th"};
-    static char html[4096];
+    static char html[4096*4];
     static int table_line_num = 0;
     static int next_is_header = 0;
     int is_header = 0;
@@ -358,7 +358,7 @@
 	snprintf(html, sizeof(html), "%s%s",
 	    table_line_num ? "</table>\n<pre>" : "", buf);
 	table_line_num = 0;
-	return html;
+	goto ret;
     }
     /* start html table */
     if (!table_line_num) {
@@ -391,6 +391,37 @@
     l += snprintf(html + l, sizeof(html) - l, "</tr>\n");
     next_is_header = is_header && strstr(buf, "\t\t");
     table_line_num++;
+ret:
+    {
+#define STRLEN(x)	(sizeof(x)-1)
+	char*pok, *found;
+	for(pok = html; pok = strstr(pok+4, "://"); )
+#define CHECKFOR(str)	(!memcmp(found=pok-STRLEN(str),str,STRLEN(str)))
+	    if(CHECKFOR("http")||CHECKFOR("ftp")||
+		CHECKFOR("gopher")||CHECKFOR("wais")) {
+		static const char prefix[]="<a href=\"", interfix[]="\">",
+		    postfix[]="</a>";
+		size_t len,restlen;
+		for(;;) {
+		    switch(*++pok) {
+			default:
+			    continue;
+			case ' ':case '\t':case '\n':case '\0':
+			    break;
+		    }
+		    break;
+		}
+		len=pok-found; restlen=strlen(pok)+1;
+		memmove(found+STRLEN(prefix)+len+STRLEN(interfix)+len+
+		    STRLEN(postfix),found+len,restlen);
+		memmove(found+STRLEN(prefix),found,len);
+		memcpy(found,prefix,STRLEN(prefix));
+		memcpy(pok = found+STRLEN(prefix)+len,
+		    interfix,STRLEN(interfix));
+		memcpy(pok += STRLEN(interfix),found+STRLEN(prefix),len);
+		memcpy(pok += len, postfix,STRLEN(postfix));
+	    }
+    }
     return html;
 }
 
@@ -440,6 +471,7 @@
 	case isHeaders:
 	    /* forward header field */
 	    if (!strcmp(buf, "\r\n")) {		/* end of headers */
+		fputs("Cache-Control: max-age=4\r\n", stdout);	/* add our type */
 		fputs("Content-Type: text/html\r\n", stdout);	/* add our type */
 		istate = isBodyStart;
 	    }
Index: squid/src/cf.data.pre
diff -u squid/src/cf.data.pre:1.1.1.2 squid/src/cf.data.pre:1.1.1.2.10.1
--- squid/src/cf.data.pre:1.1.1.2	Tue Jan 25 19:23:10 2000
+++ squid/src/cf.data.pre	Fri Nov 10 10:44:52 2000
@@ -69,6 +69,17 @@
 http_port 3128
 DOC_END
 
+NAME: bhttp_port ascii_port
+TYPE: ushort
+DEFAULT: none
+LOC: Config.Port.bhttp
+DOC_START
+	The port number where Squid uses the cuciwhirl junkfilter.
+	Note that you need another http_port directive to actually
+	bind the port.
+
+bhttp_port 3129
+DOC_END
 
 NAME: icp_port udp_port
 TYPE: ushort
@@ -494,12 +505,17 @@
 DEFAULT: 95
 LOC: Config.Swap.highWaterMark
 DOC_START
-	The low- and high-water marks for cache LRU replacement.  LRU
-	replacement begins when the high-water mark is reached and ends
-	when enough objects have been removed and the low-water mark is
-	reached. Defaults are 90% and 95%. If you have a large cache, 5%
-	could be hundreds of MB. If this is the case you may wish to
-	set these numbers closer together.
+
+	The low- and high-water marks for cache object replacement.
+	Replacement begins when the swap (disk) usage is above the
+	low-water mark and attempts to maintain utilization near the
+	low-water mark.  As swap utilization gets close to high-water
+	mark object eviction becomes more aggressive.  If utilization is
+	close to the low-water mark less replacement is done each time.
+	
+	Defaults are 90% and 95%. If you have a large cache, 5% could be
+	hundreds of MB. If this is the case you may wish to set these
+	numbers closer together.
 
 cache_swap_low  90
 cache_swap_high 95
@@ -518,6 +534,10 @@
 	hits).  If you wish to increase speed more than your want to
 	save bandwidth you should leave this low.
 
+	NOTE: if using the LFUDA replacement policy you should increase
+	this value to maximize the byte hit rate improvement of LFUDA!
+	See replacement_policy below for a discussion of this policy.
+
 maximum_object_size 4096 KB
 DOC_END
 
@@ -1092,6 +1112,49 @@
 DOC_END
 
 
+NAME: replacement_policy
+TYPE: string
+LOC: Config.replPolicy
+DEFAULT: LFUDA
+IFDEF: HPL_REPL
+DOC_START
+	The cache replacement policy parameter determines which objects
+	are evicted (replaced) when disk space is needed.  Squid used to
+	have only a single replacement policy, LRU.  But when built with
+	-DHPL_REPL you can choose between two new, enhanced policies:
+
+		   GDSF: Greedy-Dual Size Frequency
+		   LFUDA: Least Frequently Used with Dynamic Aging
+
+	Both of these policies are frequency based rather than recency
+	based, and perform better than LRU.
+
+	The GDSF policy optimizes object hit rate by keeping smaller
+	popular objects in cache so it has a better chance of getting a
+	hit.  It achieves a lower byte hit rate than LFUDA though since
+	it evicts larger (possibly popular) objects.
+
+	The LFUDA policy keeps popular objects in cache regardless of
+	their size and thus optimizes byte hit rate at the expense of
+	hit rate since one large, popular object will prevent many
+	smaller, slightly less popular objects from being cached.
+
+	Both policies utilize a dynamic aging mechanism that prevents
+	cache pollution that can otherwise occur with frequency-based
+	replacement policies.
+
+	NOTE: if using the LFUDA replacement policy you should increase
+	the value of maximum_object_size above its default of 4096 KB to
+	to maximize the potential byte hit rate improvement of LFUDA.  
+
+	For more information about these cache replacement policies see
+	http://www.hpl.hp.com/personal/John_Dilley/caching/wcw.html and
+	http://fog.hpl.external.hp.com/techreports/98/HPL-98-173.html.
+
+replacement_policy LFUDA
+DOC_END
+
+
 NAME: reference_age
 TYPE: time_t
 LOC: Config.referenceAge
@@ -1114,6 +1177,9 @@
 		4 months
 		2.2 hours
 
+	NOTE: this parameter is not used when using the enhanced
+	replacement policies, GDSH or LFUDA.
+
 reference_age 1 month
 DOC_END
 
